// HPSelectionSet.h : interface of the HPSelectionSet class, derived from HSelectionSet
// adds app-specific overlooading of selection functions to support PK_face, PK_body and
// PK_egde level selection/highlighting

#ifndef _HSSELECTIONSET_H
#define _HSSELECTIONSET_H

#ifdef PARASOLID 
#include "parasolid_kernel.h"
#include "kernel_interface.h"
#endif

#include "HSelectionSet.h"


class HSSelectionSet :  public HSelectionSet 
{

private:
#ifdef PARASOLID
	PK_CLASS_t	m_SelectLevel;
#endif
#ifdef ACIS
	int	m_SelectLevel;
#endif

	HVarray *	m_pSolidSelection;

public:
	HSSelectionSet(HBaseView* view);
	~HSSelectionSet();

	// overloaded virtuals
	void Init();
	void Select(long key, char* segpath, long include_key, long includer_key);
    void DeSelect(long key);
	void DeSelectAll ();
    bool IsSelected(long key);
	void Reset();
	
	long GetAtSolidEntity(int index);
    int  GetSolidListSize();

	// selection level support
#ifdef PARASOLID
	void SetSelectLevel(PK_CLASS_t level) { m_SelectLevel = level; }
	const PK_CLASS_t GetSelectLevel() { return (m_SelectLevel);}
#endif
#ifdef ACIS
	void SetSelectLevel(int level) { m_SelectLevel = level; }
	const int GetSelectLevel() { return m_SelectLevel; }
#endif
	
};

#endif





